var fs = require('fs');
var vm = require('vm');
var path = require("path");

var runJob = function(jobPath, param, callback){
  var SherlockContext = require('./sherlockContext.js');
  var context = new SherlockContext();
  var pathToJob = path.join(jobPath);
  var data = fs.readFileSync(pathToJob);
  var jobContent = data+"";
  context.answers=param;

  if(path.extname(jobPath) == ".coffee"){
    require('./sherlockCoffeeJobExecutor')(jobContent, {sandbox: context, filename: 'sherlockJobContext.coffee'}, callback);
  }else{
    vm.runInNewContext(jobContent, context, {filename: 'sherlockContext.js'});
  }

  context.on('end', function(conclusions){
    if(callback){
      callback(conclusions);
    }
  });
}

module.exports.run = runJob;