var winston = require('winston');
var d3 = require('d3');
var readdir = require('readdir');
var path = require('path');

var genericCommands = readdir.readSync(__dirname, ['**.js']);
genericCommands.forEach(function(command){
	var normCommand = path.basename(command,".js");
	//console.log('Loading command: '+normCommand);
	module.exports[normCommand]=require("./"+command);
});

var commandDir = path.join(process.cwd(), "commands");
var localCommands = readdir.readSync(commandDir, ['**.js']);
localCommands.forEach(function(command){
	var normcommand = path.basename(command,".js");
	//console.log('Loading local command: '+normcommand);
	module.exports[normcommand]=require(commandDir+"/./"+command);
});


module.exports.genericCommands = genericCommands;
module.exports.localCommands = localCommands;