{EventEmitter} = require 'events'
Step = require './step'
Context = require './context'
async = require 'async'

class Flow extends EventEmitter
  constructor: (@steps=[], @context)->
    throw 'context parameter must be a Context instance' if @context? and @context not instanceof Context
  add: (step) ->
    if step instanceof Step
      @steps.push step
    else
      throw 'add must receive a Step instance as parameter'
  steps: ->
    @steps
  execute: ->
    async.mapSeries @steps, @executeStep, (err, results) =>
      @emit 'end_flow', err, results
  executeStep: (step, callback) =>
    step.execute(@context)
    step.on 'end', (err, results) ->
      results.type = step.constructor.name
      callback null, results

module.exports=Flow