Scp2 = require('scp2')
Step = require('./step')
Auth  = require '../../utils/authUtil.js'

class SCP extends Step
  constructor: (@servers, @scpPort=22) ->
    throw '[SCP] servers parameter is required' if !@servers or @servers.length <= 0
  execute: (context) ->
    @connect Auth.getUsername(), Auth.getPassword(), context.scpRequest
  connect: (username, password, options) ->
    throw 'options parameter is required' if !options or options.length <= 0
    configuration =
      host: @servers
      port: @scpPort
      username: username
      password: password
      path: options.path

    Scp2.scp configuration, options.target, (err) =>
      console.log err if err?
      response =
        path: configuration.path
        target: options.target
        host: @servers
        port: @scpPort

      @emit 'end', err, response

module.exports=SCP