Step = require './step'
JobRunner = require '../../runner/jobRunner'
Auth  = require '../../utils/authUtil.js'

class SSH extends Step
  constructor: (@servers, @sshPort=22)->
    throw '[SSH] servers parameter is required' if !@servers or @servers.length <= 0
  execute: (context) ->
    @connect Auth.getUsername(), Auth.getPassword(), context.sshRequest.commands
  connect: (username, password, commands) ->
    throw 'commands parameter is required' if !commands or commands.length <= 0
    configuration =
      servers: @servers
      sshPort: @sshPort
      username: username
      password: password
      report:
        commands: commands
      stream: false

    runner = new JobRunner configuration
    if configuration.stream is true
      runner.on 'data', (results) =>
        @emit 'data', results

    runner.on 'consolidate', (results) =>
      @emit 'end', null, results
    runner.run()

module.exports=SSH