module.exports = function(results) {
	var Table = require('cli-table');
	var d3 = require('d3');
	var commands = d3.map();
	var serversResults = d3.map(results.conclusion._);

	serversResults.forEach(function(res) {
		serversResults.get(res).forEach(function(command) {
			if (commands.has(command.command.name)) {
				commands.get(command.command.name).push(command.rawData);
			} else {
				commands.set(command.command.name, [command.rawData]);
			}
		});
	});

	var servers = ["Command"].concat(serversResults.keys());

	var cross_table = new Table({
		head: servers
	});
	commands.forEach(function(command) {
		commandName = command;
		var row = {};
		row[commandName] = commands.get(command);
		cross_table.push(row);
	});

	console.log(cross_table.toString());
}