var Table = require('cli-table');
var cli = require('cli-color');
var d3 = require('d3');
var numeral = require('numeral');


module.exports = function(results){
		results = d3.map(results.conclusion.response._);
		var keys = results.keys();
		var origins = d3.map();
		var json = {};

		try{

			for (var i = keys.length - 1; i >= 0; i--) {
				
				var key = keys[i];
				var result = results.get(key);
				var raw = result[0].rawData;
				var values = raw.trim().split('\n');

				values.forEach(function(value){

					var sepValue = value.trim().split(' ');
					if(sKey != ''){
						var sKey = sepValue[1].replace('origin=','');
						var sVal = sepValue[0];

						if(!json[sKey]) {
							json[sKey] = [];
						}

						json[sKey].push({ server : key, value : sVal });

						if(origins.has(sKey)){
							origins.get(sKey).push(sVal);
						}else{
							origins.set(sKey,[sVal]);
						}
					}
				});

			};

			for (key in json) {
				var arr = json[key];
				for (var i = 0; i < keys.length; i++) {
					var server = keys[i];
					if(JSON.stringify(arr).indexOf(server) < 0) {
						json[key].push({ server: server, value: 0 });
					}
				}
			}

		}catch(err){
			console.log('Error: '+err);
		}

		var head =['#'];
		var aggregation = 0;

		// monta cabeçalho da tabela
		Object.keys(json).forEach(function(key) {
			var valueArray = json[key];
			valueArray.sort(function(a, b){
				return a.server.localeCompare(b.server)
			});
		    Object.keys(valueArray).forEach(function(i) {
		    	var value = valueArray[i].value;
		    	values.push(value);
		    	aggregation += parseInt(value);
		    	if(head.indexOf(valueArray[i].server) < 0) {
		    		head.push(valueArray[i].server);
		    	}
			});

		});

		head.push('TOTAL');
		head.push('%');
		var table = new Table({head:head, style : {compact : true, 'padding-left' : 1}});

		Object.keys(json).forEach(function(key) {
			
			var valueArray = json[key];

			valueArray.sort(function(a, b){
				return a.server.localeCompare(b.server)
			});
		    
		    var values = [];
		    var valuesNum = [];
		    var obj = {};
		    
		    Object.keys(valueArray).forEach(function(i) {
		    	var num = valueArray[i].value;
		    	valuesNum.push(num);
		    	values.push(numeral(num).format('0,0'));
			});

			var total = d3.sum(valuesNum);
			var percent = ((parseInt(total) / aggregation) * 100).toFixed(5);

			values.push(numeral(total).format('0,0'));
			values.push(percent);

			obj[key]=values;
			table.push(obj);

		});

		console.log(table.toString());
}