var ChoicesFlow = require("../models/choicesFlow.js");
var Stage 		= require("../models/stage.js");
var JobRunner   = require("../runner/jobRunner.js");
var flow 		= new ChoicesFlow();

var stage = new Stage("Simple questions");
stage.addQuestion({
	type: "input",
	name: "servers",
	message: "Inform servers sepated by comma",
	default: 'prod-saas-1,prod-saas-2,prod-saas-3,prod-saas-4'
});
stage.addQuestion({
	type: "input",
	name: "time",
	message: "Inform min time in miliseconds",
	default:1000
});

stage.addQuestion({
	type: "input",
	name: "date",
	message: "Inform date of log, ex: 2014-11-11",
	default:'TODAY'
});

stage.after(function(answers, callback){
	var serversContent=answers.servers;
	answers.servers=serversContent.split(",");
	callback();
});
flow.registerStage(stage);

flow.start(function(err, answers){
	console.log(answers);
	var authUtil = require('../utils/authUtil.js');
	var mainCommand = 'cat /walmart/log/ws-search-service/search.log  | grep requestLogger  | awk \'{print substr($NF, 2, index($NF, "]")-2)}\' | awk \'{if ($1 > '+answers.time+') print $0}\' | wc -l';
	if(answers.date != 'TODAY'){
		mainCommand = 'zgrep requestLogger /walmart/log/ws-search-service/search-'+answers.date+'.log.gz  | awk \'{print substr($NF, 2, index($NF, "]")-2)}\' | awk \'{if ($1 > '+answers.time+') print $0}\' | wc -l';
	}
	var options={
		servers:answers.servers,
		username: authUtil.getUsername(),
		password: authUtil.getPassword(),
		report:{
			name:'QPS',
			commands: [mainCommand]
		}
	}

	var runner = new JobRunner(options);

	runner.on('consolidate', function(results){
		results.keys().forEach(function(server){
			var result = results.get(server);
			console.log('Result for: '+server);
			console.log(result[0].rawData);
		});
	});

	runner.run();
});