var ChoicesFlow = require("../models/choicesFlow.js");
var Stage 		= require("../models/stage.js");
var JobRunner   = require("../runner/jobRunner.js");
var flow 		= new ChoicesFlow();

var stage = new Stage("Simple questions");
stage.addQuestion({
	type: "input",
	name: "servers",
	message: "Inform servers sepated by comma",
	default: 'prod-saas-1,prod-saas-2,prod-saas-3,prod-saas-4'
});

stage.addQuestion({
	type: "list",
	name: "type",
	message: "Select error type",
	choices:[
		"invalid parameter using solr",
		"parameters is not valid",
		"NOT - invalid parameter using solr"
	]
});

stage.after(function(answers, callback){
	var serversContent=answers.servers;
	answers.servers=serversContent.split(",");
	callback();
});
flow.registerStage(stage);

flow.start(function(err, answers){
	//console.log(answers);
	var authUtil = require('../utils/authUtil.js');
	var mainCommand = ""
	if(answers.type == "NOT - invalid parameter using solr"){
		mainCommand = 'cat /walmart/log/ws-search-service/search.log | grep requestLogger | grep fail | grep -v \"invalid parameter using solr\" | wc -l ';
	}else{
		mainCommand = 'cat /walmart/log/ws-search-service/search.log | grep requestLogger | grep fail | grep \"'+answers.type+'\" | wc -l ';
	}
	
	var options={
		servers:answers.servers,
		username: authUtil.getUsername(),
		password: authUtil.getPassword(),
		report:{
			name:'QPS',
			commands: [mainCommand]
		}
	}

	var runner = new JobRunner(options);

	runner.on('consolidate', function(results){
		results.keys().forEach(function(server){
			var result = results.get(server);
			console.log('Result for: '+server);
			console.log(result);
		});
	});

	runner.run();
});