var ChoicesFlow = require("../models/choicesFlow.js");
var Stage 		= require("../models/stage.js");
var JobRunner   = require("../runner/jobRunner.js");
var flow 		= new ChoicesFlow();

var stage = new Stage("Simple questions");
stage.addQuestion({
	type: "input",
	name: "servers",
	message: "Inform servers sepated by comma",
	default: 'prod-solr-2,prod-solr-3,prod-solr-4,prod-solr-5,prod-solr-6,prod-solr-7,prod-solr-8,prod-solr-9,prod-solr-10,prod-solr-11,prod-solr-12,prod-solr-13,prod-solr-14,prod-solr-15,prod-solr-16,prod-solr-17,prod-solr-18,prod-solr-19,prod-solr-20,prod-solr-21'
});

stage.addQuestion({
	type: "input",
	name: "start",
	message: "Start time",
	default: '10:00'
});

stage.addQuestion({
	type: "input",
	name: "end",
	message: "End time",
	default: '11:00'
});

stage.after(function(answers, callback){
	var serversContent=answers.servers;
	answers.servers=serversContent.split(",");
	callback();
});
flow.registerStage(stage);

flow.start(function(err, answers){
	console.log(answers);
	var authUtil = require('../utils/authUtil.js');
	var options={
		servers:answers.servers,
		username: authUtil.getUsername(),
		password: authUtil.getPassword(),
		report:{
			name:'QPS',
			commands: ['cat /walmart/log/solr/solr.log | grep INFO | awk \'{print substr($4, 1, 8)}\' | sort | uniq -c | sort -gr | head -15']
		}
	}

	var runner = new JobRunner(options);

	runner.on('consolidate', function(results){
		results.keys().forEach(function(server){
			var result = results.get(server);
			console.log('Result for: '+server);
			console.log(result[0].rawData);
		});
	});

	console.log('Starting Runner');
	runner.run();
});