var JobRunner   = require("../runner/jobRunner.js");

var authUtil = require('../utils/authUtil.js');
var options={
	servers:['prod-saas-1'],
	username: authUtil.getUsername(),
	password: authUtil.getPassword(),
	report:{
		name:'QPS',
		commands: ['tail -f /walmart/log/ws-search-service/search.log']
	}
}

var runner = new JobRunner(options);

runner.on('data', function(data){
	console.log(data.server + " - "+data.rawData);
});

runner.on('consolidate', function(results){
	results.keys().forEach(function(server){
		var result = results.get(server);
		console.log('Result for: '+server);
		console.log(result);
	});
});

runner.run();