var inquirer = require("inquirer");
var async = require("async");
var winston = require("winston");
var merge = require('merge');

//Module responsible for aggregate stages and execute them.
module.exports = function(){
	var answers= {};
	return {
		stages:[],
		verifyStages:{},
		queue: async.queue(function (stage, callback) {
		    stage.execute(answers, function(err, response){
		    	answers = merge(answers, response);
		    	callback();
		    });
		}, 1),
		//Register a stage object
		registerStage: function(stage, previousAnswers){
			//The instance of stage receives the instance of your controller. It's allow register new subStages in after callback from stage
			stage.registerController(this);
			if(previousAnswers){
				answers = merge(answers, previousAnswers);
			}
			this.queue.push(stage, function(){
			});
		},
		start: function(callback){
			this.queue.drain=function(){
				callback(null, answers);
			}
		}
	}
}