var environment = {
	'prod' : {
		'saas' : {
			servers : ['prod-saas-1','prod-saas-2','prod-saas-3','prod-saas-4'],
			accesslog : '/var/log/nginx/access-saas.log*',
			applog : '/walmart/log/ws-search-service/search.log'
		},
		'suggest' : {
			servers : ['prod-suggest-1','prod-suggest-2','prod-suggest-3','prod-suggest-4'],
			accesslog : '/var/log/nginx/access-suggest.log*',
			applog : '/walmart/log/ws-search-suggest/search.log'
		},
		'solr_slaves' : {
			servers : ['prod-solr-2','prod-solr-3','prod-solr-4','prod-solr-5','prod-solr-6','prod-solr-7','prod-solr-8','prod-solr-9','prod-solr-10','prod-solr-11','prod-solr-12','prod-solr-13','prod-solr-14','prod-solr-15','prod-solr-16','prod-solr-17','prod-solr-18','prod-solr-19','prod-solr-20','prod-solr-21'],
			accesslog : '/var/log/nginx/access.log',
			applog : '/walmart/log/solr/solr.log'
		},
		'solr_master' : {
			servers : ['prod-solr-1'],
			accesslog : '/var/log/nginx/access.log',
			applog : '/walmart/log/solr/solr.log'
		},
		'indexer' : {
			servers : ['prod-indexer-1', 'prod-indexer-2'],
			accesslog : '/var/log/nginx/access.log',
			applog : '/walmart/log/ws-search-indexer/search*.log'
		},
		'cache_varnish' : {
			servers : ['prod-cache-1', 'prod-cache-2', 'prod-cache-3', 'prod-cache-4'],
			accesslog : '/var/log/varnish/varnishncsa.log*'
		}
	},
	'stage' : {
		'saas' : {
			servers : ['stage-saas-1','stage-saas-2','stage-saas-3','stage-saas-4'],
			accesslog : '/var/log/nginx/access-saas.log*',
			applog : '/walmart/log/ws-search-service/search.log'
		},
		'suggest' : {
			servers : ['stage-suggest-1','stage-suggest-2','stage-suggest-3','stage-suggest-4'],
			accesslog : '/var/log/nginx/access-suggest.log*',
			applog : '/walmart/log/ws-search-suggest/search.log'
		},
		'solr_slaves' : {
			servers : ['stage-solr-2','stage-solr-3','stage-solr-4','stage-solr-5','stage-solr-6','stage-solr-7','stage-solr-8','stage-solr-9','stage-solr-10','stage-solr-11','stage-solr-12','stage-solr-13','stage-solr-14','stage-solr-15','stage-solr-16','stage-solr-17','stage-solr-18','stage-solr-19','stage-solr-20','stage-solr-21'],
			accesslog : '/var/log/nginx/access.log',
			applog : '/walmart/log/solr/solr.log'
		},
		'solr_master' : {
			servers : ['stage-solr-1'],
			accesslog : '/var/log/nginx/access.log',
			applog : '/walmart/log/solr/solr.log'
		}
	},
	'qa' : {
		'saas' : {
			servers : ['qa-saas-1','qa-saas-2'],
			accesslog : '/var/log/nginx/access-saas.log*',
			applog : '/walmart/log/ws-search-service/search.log'
		},
		'suggest' : {
			servers : ['qa-suggest-1','qa-suggest-2'],
			accesslog : '/var/log/nginx/access-suggest.log*',
			applog : '/walmart/log/ws-search-suggest/search.log'
		},
		'solr_slaves' : {
			servers : ['qa-solr-2'],
			accesslog : '/var/log/nginx/access.log',
			applog : '/walmart/log/solr/solr.log'
		},
		'solr_master' : {
			servers : ['qa-solr-1'],
			accesslog : '/var/log/nginx/access.log',
			applog : '/walmart/log/solr/solr.log'
		},
		'indexer' : {
			servers : ['qa-indexer-1', 'qa-indexer-2'],
			accesslog : '/var/log/nginx/access.log',
			applog : '/walmart/log/ws-search-indexer/search*.log'
		}
	},
};

module.exports = environment;