var commands = require('../helpers/commands/commands.js');
var vis = require('../helpers/visualizations/visualizations.js');

var generic = vis.genericVisualizations.map(function(visu){
  return "[Default] "+visu;
});

var local = vis.localVisualizations.map(function(visu){
  return "[Local] "+visu;
});

var blessed = require('blessed');
var contrib = require('blessed-contrib');

var genericCommands = commands.genericCommands.map(function(visu){
  return "[Default] "+visu;
});

var localCommand = commands.localCommands.map(function(visu){
  return "[Local] "+visu;
});

var visualizations = generic.concat(local);
var commandsList = genericCommands.concat(localCommand);

var screen = blessed.screen();
var grid = new contrib.grid({rows: 2, cols: 2})

//grid.set(row, col, rowSpan, colSpan, obj, opts)
grid.set(0, 0, 1, 1, blessed.box, {content: 'Visualizations:\t\n'+ visualizations.join('\t\n')});
grid.set(1, 0, 1, 1, blessed.box, {content: 'Commands\t\n'+commandsList.join('\t\n')});
//grid.set(2, 0, 2, 1, blessed.box, {content: 'Jobs'});

grid.applyLayout(screen);

screen.render();