var Stage = require("../models/stage.js");
var fs = require("fs");
var path = require("path");
var mkdirp = require('mkdirp');

//###########################################
//###### Configuring Stage
//###########################################
var authenticationStage = new Stage("Configuration of Authentication");
authenticationStage.applyWhen(function(answers){
	var userHome = getUserHome();
	var usernameConfig=path.join(userHome, '.sherlock', 'auth');
	return !fs.existsSync(usernameConfig);
});

function getUserHome() {
  return process.env[(process.platform == 'win32') ? 'USERPROFILE' : 'HOME'];
}

authenticationStage.addQuestion({
	type: "input",
	name: "username",
	message: "Username"
});

authenticationStage.addQuestion({
	type: "password",
	name: "password",
	message: "Password"
});

authenticationStage.after(function(answers, callback){
	if(answers.username != null && answers.password!=null){
		var usernameConfigDir=path.join(getUserHome(), '.sherlock');
		mkdirp(usernameConfigDir, 0755, function(err){
			if (err){
				console.log(err);
				throw err;
			} 
			console.log('   \033[36mcreate\033[0m : ' + usernameConfigDir);
			var usernameConfigFile = path.join(usernameConfigDir, 'auth');
			fs.writeFile(usernameConfigFile, JSON.stringify(answers), function (err) {
			  if (err) throw err;
			  console.log('   \033[36mcreate\033[0m : ' + usernameConfigFile);
			  callback();
			});
		});
	}
});

module.exports=authenticationStage;