var Stage = require("../models/stage.js");
var fs = require("fs");
var path = require("path");
var mkdirp = require('mkdirp');
var async = require('async');
var sherlockFile = path.join('.', 'sherlock.json');
var config={};

//###########################################
//###### Configuring Stage
//###########################################
var loadDefaultJobStage = new Stage("Load create reports");
loadDefaultJobStage.applyWhen(function(answers){
	return answers.mainOption === "Create Report";
});

var jobPath = path.join(__dirname, '..','jobs');
var jobs = fs.readdirSync(jobPath);

var choices=[];
for (var i = jobs.length - 1; i >= 0; i--) {
	var job = jobs[i];
	choices.push(job);
};

loadDefaultJobStage.addQuestion({
	type: "input",
	name: "commandName",
	message: "Job name"
});

loadDefaultJobStage.addQuestion({
	type: "input",
	name: "command",
	message: "Command"
});

//###########################################
//###### Configuring Stage
//###########################################
loadDefaultJobStage.after(function(answers, callback){
	var job = path.join(__dirname, '..','jobs', answers.selectedJob);
	try{
		var instance = require(job);
	}catch(err){
		console.log(err);
	}
	callback();
});

module.exports = loadDefaultJobStage;