var Stage = require("../models/stage.js");
var vm = require('vm');
var fs = require("fs");
var path = require("path");
var mkdirp = require('mkdirp');
var async = require('async');
var sherlockFile = path.join('.', 'sherlock.json');
var SherlockContext = require('../context/sherlockContext.js');
var SherlockJobExecutor = require('../context/sherlockJobExecutor');
var config={};

//###########################################
//###### Configuring Stage
//###########################################
var exists = fs.existsSync('jobs');
var loadDefaultJobStage = new Stage("Load default jobs");
loadDefaultJobStage.applyWhen(function(answers){
	return answers.mainOption === "Run report";
});


var jobs = [];
if(exists){
	var jobPath = path.join('jobs');
	jobs=fs.readdirSync(jobPath);
}

var choices=[];
for (var i = jobs.length - 1; i >= 0; i--) {
	var job = jobs[i];
	choices.push(job);
};

loadDefaultJobStage.applyWhen(function(answers){
	return choices.length > 0;
});

loadDefaultJobStage.addQuestion({
	type: "list",
	name: "selectedJob",
	message: "Select one job to run",
	choices: choices.sort()
});
//###########################################
//###### Configuring Stage
//###########################################
loadDefaultJobStage.after(function(answers, callback){
	var jobPath = path.join('jobs', answers.selectedJob);
	SherlockJobExecutor.run(jobPath, {}, function(conclusions){
		callback();
	});
});

module.exports = loadDefaultJobStage;