var Table = require('cli-table');
var d3 = require('d3');
var cli = require('cli-color');

module.exports.simpleTableFromResults=function(results, commandName){
	var keys = results.keys();
	var origins = d3.map();
	var json = {};

	try{

		for (var i = keys.length - 1; i >= 0; i--) {

			var key = keys[i];
			var result = results.get(key);
			var raw = extractValueByCommandName(result, commandName);
			var values = raw.trim().split('\n');
			var j = 1;

			values.forEach(function(value){

				var sKey = j++;
				var sVal = value.replace(/\s+/, " ").trim();

				if(!json[sKey]) {
					json[sKey] = [];
				}

				json[sKey].push({ server : key, value : sVal });

				if(origins.has(sKey)){
					origins.get(sKey).push(sVal);
				}else{
					origins.set(sKey,[sVal]);
				}
			});

		};

	}catch(err){
		console.log('Error: '+err);
	}

	var head =['#'];

		// monta cabeçalho da tabela
		Object.keys(json).forEach(function(key) {
			var valueArray = json[key];
			valueArray.sort(function(a, b){
				return a.server.localeCompare(b.server)
			});
			Object.keys(valueArray).forEach(function(i) {
				var value = valueArray[i].value;
				values.push(value);
				if(head.indexOf(valueArray[i].server) < 0) {
					head.push(valueArray[i].server);
				}
			});

		});

		head.push('TOTAL');
		var table = new Table({head:head, style : {compact : true, 'padding-left' : 1}});

		Object.keys(json).forEach(function(key) {
			
			var valueArray = json[key];
			var total = 0;

			valueArray.sort(function(a, b){
				return a.server.localeCompare(b.server)
			});

			var values = [];
			var obj = {};

			Object.keys(valueArray).forEach(function(i) {
				total += parseInt(valueArray[i].value.split(" ")[0]);
				values.push(valueArray[i].value);
			});

			values.push(total);

			obj[key]=values;
			table.push(obj);

		});

		console.log(cli.cyan("=== === === === === === === ==="));
		console.log(cli.cyan(''+commandName));
		console.log(cli.cyan("=== === === === === === === ==="));

		console.log(table.toString());
}

function extractValueByCommandName(result, commandName){
	var res='';
	result.forEach(function(command){
		if(command.command.name === commandName){
			res=command.rawData;
		}
	});
	return res;
}