var Stage = require("../app/models/stage.js");
var ChoicesFlow = require("../app/models/choicesFlow.js");

var flow = new ChoicesFlow();

stage1 = new Stage("Ask for first name");
stage2 = new Stage("Ask for last name");
stage3 = new Stage("Ask for phone number");

stage1.applyWhen(function(answers){
	return true;
});

stage2.applyWhen(function(answers){
	return answers.first_name != null;
});

stage3.applyWhen(function(answers){
	return answers.first_name == "Guilherme";
});

var question1 = {
    type: "input",
    name: "first_name",
    message: "What's your first name"
}

var question2 = {
    type: "input",
    name: "last_name",
    message: "What's your last name"
}

var question3 = {
    type: "input",
    name: "phone_number",
    message: "What's your phone number"
}

stage1.addQuestion(question1);
stage2.addQuestion(question2);
stage3.addQuestion(question3);

stage3.before(function(answer){
	console.log("Before");
});

stage3.after(function(answer){
	console.log("After");
});

flow.registerStage(stage1);
flow.registerStage(stage2);
flow.registerStage(stage3);


flow.start(function(err, answers){
	console.log(err);
	console.log(answers);
});