var fs = require('fs');
var d3 = require('d3');
var xmldom = require('xmldom');
 
var data = d3.range(10);
var max = d3.max(data);
var height = 200;
var scale = height / max;
var scaled_data = data.map(function(d){ return d * scale;});
console.log(scaled_data);
var svg = d3.select('body')
                .append('svg').attr({
                  width: '1024px',
                  height: '1024px'
                })
                .selectAll('rect')
                .data(scaled_data)
                .enter().append('rect')
              .attr({
                width: 50,
                "stroke": "white",
                "stroke-width":"1",
                "fill": "blue",
                height: function(d){ return d }, 
                x: function(d, i){ return i * 50 },
                y: function(d){ return height - d }
              });

// get a reference to our SVG object and add the SVG NS  
var svgGraph = d3.select('svg')
  .attr('xmlns', 'http://www.w3.org/2000/svg');
var svgXML = (new xmldom.XMLSerializer()).serializeToString(svgGraph[0][0]);

console.log(svgXML);
svgXML = svgXML.toLowerCase();
console.log(svgXML);

fs.writeFile('graph.svg', svgXML);