var assert = require("assert");
var should = require('should');

describe("SherlockContext test", function(){
  it("Should instantiate a SherlockContext", function(){
    var SherlockContext = require("../../../app/context/sherlockContext");
    should.exist(SherlockContext);
    var context = new SherlockContext();
    should.exist(context);
    should.exist(context.console);
    should.exist(context.require);
    should.exist(context.process);
    should.exist(context.setInterval);
    should.exist(context.context.environment, 'context.environment should exist');
    should.exist(context.context.visualizations, 'context.visualizations should exist');
    should.exist(context.context.commands, 'context.commands should exist');
    should.exist(context.context.investigations, 'context.investigations should exist');
    should.exist(context.context.questions, 'context.questions should exist');
    should.exist(context.context.conclusions, 'context.conclusions should exist');
    should.exist(context.skip, 'skip should exist');
    should.exist(context.investigation, 'investigation should exist');
    should.exist(context.investigate, 'investigate should exist');
    should.exist(context.ask, 'ask should exist');
    should.exist(context.check, 'check should exist');
    should.exist(context.conclusion, 'conclusion should exist');
    should.exist(context.conclude, 'conclude should exist');
  });

  it("Should emit event when job execution end", function(done){
    var SherlockContext = require("../../../app/context/sherlockContext");
    should.exist(SherlockContext);
    var context = new SherlockContext();
    var dataToEmit = {status:200, message: "success"};
    context.on('end', function(data){
      data.should.be.equal(dataToEmit);
      done();
    });

    context.emit('end', dataToEmit);
  });
});