require('coffee-script/register');
var chai = require('chai');
var expect = chai.expect;
var should = require('should');

var Local = require('../../../../app/helpers/executions/local.coffee');
var Command = require('../../../../app/helpers/executions/command.coffee');

describe("Local - spec", function(){

  it('should instantiate Local', function(){
    var local = new Local();
    should.exist(local);
  });

  it('should throw exception when try execute local with no command', function(){
    var local = new Local();
    should.exist(local);

    try{
      local.connect(null);
    }catch(error){
      error.should.be.equal('command parameter is required');
    }
  });

  it('should execute local command', function(done){
    var local = new Local();
    should.exist(local);
    try{
      local.on('executed', function(err, response){
        true.should.equal(err == null);
        false.should.equal(response['Uname'].stderr == null);
        response['Uname'].stderr.should.be.empty;
        response['Uname'].rawData.should.not.be.empty;
        done();
      });
      local.connect(new Command('Uname', 'uname -a'));
    }catch(error){
      error.should.be.equal('command parameter is required');
    }
  });
})