require('coffee-script/register');
var chai = require('chai');
var should = require('should');
var expect = chai.expect;

describe("SSH - spec", function(){
  it('should throw message error when servers isnt in constructor', function(){
    var SSH = require('../../../../app/helpers/executions/ssh.coffee');
    try{
      new SSH();
    }catch(error){
      error.should.be.equal('[SSH] servers parameter is required');
    }
  });

  it('should throw message error when servers were empty in constructor', function(){
    var SSH = require('../../../../app/helpers/executions/ssh.coffee');
    try{
      new SSH([]);
    }catch(error){
      error.should.be.equal('[SSH] servers parameter is required');
    }
  });

  it('should instantiate SSH', function(){
    var SSH = require('../../../../app/helpers/executions/ssh.coffee');
    var servers = ['127.0.0.1'];
    var sshPort = 2222;
    var ssh = new SSH(servers, sshPort);
    should.exist(ssh);
    servers.should.be.equal(ssh.servers);
    sshPort.should.be.equal(ssh.sshPort);
  });

  it('should throw exception when try connect SSH to server with no command', function(){
    this.timeout(10000);
    var SSH = require('../../../../app/helpers/executions/ssh.coffee');
    var servers = ['127.0.0.1'];
    var sshPort = 2222;
    var ssh = new SSH(servers, sshPort);
    should.exist(ssh);
    servers.should.be.equal(ssh.servers);
    sshPort.should.be.equal(ssh.sshPort);

    try{
      ssh.connect('root', '5tgbnhy6', null);
    }catch(error){
      error.should.be.equal('commands parameter is required');
    }
  });

  it('should connect SSH to server', function(done){
    this.timeout(10000);
    var SSH = require('../../../../app/helpers/executions/ssh.coffee');
    var servers = ['127.0.0.1', 'localhost'];
    var sshPort = 2222;
    var ssh = new SSH(servers, sshPort);
    should.exist(ssh);
    servers.should.be.equal(ssh.servers);
    sshPort.should.be.equal(ssh.sshPort);

    commands =[
      {name:'Hello', command: 'echo "Hello Sherlock"'},
      {name:'List files', command: 'ls -lart'}
    ]

    ssh.connect('root', '5tgbnhy6', commands);
    ssh.on('end', function(results){
      done();
    })
  });
})