var should = require('should');
var Stage = require("../../../app/models/stage.js");
var ChoicesFlow = require("../../../app/models/choicesFlow.js");

describe.skip("#Stage Specification", function(done){
	before(function(){
    	(Stage != null).should.be.true;
  	});

	it("- Should execute simple stage", function(done){
		this.timeout(10000);
		var stage = new Stage("Teste");
		var flow = new ChoicesFlow();

		stage.addQuestion({
			type: "input",
			name: "size",
			message: "Question 1",
			default: 5
		});

		stage.addQuestion({
			type: "input",
			name: "test",
			message: "Question 2",
			default: 5
		});
		flow.registerStage(stage);
		flow.start(function(err, answers){
			answers.should.have.property('size');
			answers.should.have.property('test');
			done();
		});
	});

	it("- Should add dynamic question", function(done){
		this.timeout(60000);
		var stage = new Stage("Teste");
		var flow = new ChoicesFlow();

		stage.addQuestion({
			type: "input",
			name: "name",
			message: "What is your name?"
		});

		stage.addQuestion(function(answers){
			return {
				type: "input",
				name: "age",
				message: "Hello "+answers.name+", how old are you?",
				default: 18
			}
		});

		stage.addQuestion(function(answers){
			return {
				type: "confirm",
				name: "confirm",
				message: "Hello "+answers.name+", you should are older than 18, ok?",
				apply: function (answers) {
		      		return answers.age < 18;
		    	}
			}
		});

		flow.registerStage(stage);
		flow.start(function(err, answers){
			done();
		});
	});

	it("- Should add new Stage after Stage be executed", function(done){
		this.timeout(60000);
		var stage1 = new Stage("Teste 1");
		var stage2 = new Stage("Teste 2");
		var flow = new ChoicesFlow();

		stage1.addQuestion({
			type: "input",
			name: "stage1",
			message: "What is your name?"
		});

		stage2.addQuestion({
			type: "input",
			name: "stage2",
			message: "Second stage?"
		});

		stage1.after(function(answers, callback){
			console.log(this.name);
			subStage = new Stage("Sub stage!!!");
			subStage.addQuestion({
				type: "input",
				name: "substage1",
				message: "Is this a substage?"
			});

			this.controller.registerStage(subStage);
			callback();
		});

		flow.registerStage(stage1);
		flow.registerStage(stage2);

		flow.start(function(err, answers){
			console.log(JSON.stringify(answers, null, '\t'));
			done();
		});
	});
});